
/* Chrysalide - Outil d'analyse de fichiers binaires
 * array.h - prototypes pour les manipulations de tableaux propres à Dalvik
 *
 * Copyright (C) 2010 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _DECOMP_EXPR_DALVIK_ARRAY_H
#define _DECOMP_EXPR_DALVIK_ARRAY_H


#include <glib-object.h>


#include "../../expression.h"
#include "../../instruction.h"



#define G_TYPE_DALVIK_ALENGTH               g_dalvik_alength_get_type()
#define G_DALVIK_ALENGTH(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), g_dalvik_alength_get_type(), GDalvikALength))
#define G_IS_DALVIK_ALENGTH(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_dalvik_alength_get_type()))
#define G_DALVIK_ALENGTH_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_DALVIK_ALENGTH, GDalvikALengthClass))
#define G_IS_DALVIK_ALENGTH_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_DALVIK_ALENGTH))
#define G_DALVIK_ALENGTH_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_DALVIK_ALENGTH, GDalvikALengthClass))



/* Définition d'une expression de mesure de tableau (instance) */
typedef struct _GDalvikALength GDalvikALength;

/* Définition d'une expression de mesure de tableau (classe) */
typedef struct _GDalvikALengthClass GDalvikALengthClass;



/* Indique le type défini pour une expression de mesure de tableau. */
GType g_dalvik_alength_get_type(void);

/* Construit une expression à partir d'une mesure de tableau. */
GDecInstruction *g_dalvik_alength_new(GDecExpression *);



#endif  /* _DECOMP_EXPR_DALVIK_ARRAY_H */
