
/* Chrysalide - Outil d'analyse de fichiers binaires
 * gtkblockview.h - prototypes pour l'affichage d'un fragment de code d'assemblage
 *
 * Copyright (C) 2008-2014 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _GTKEXT_GTKBLOCKVIEW_H
#define _GTKEXT_GTKBLOCKVIEW_H


#include <glib-object.h>
#include <gtk/gtk.h>



#define GTK_TYPE_BLOCK_VIEW                  (gtk_block_view_get_type())
#define GTK_BLOCK_VIEW(obj)                  (G_TYPE_CHECK_INSTANCE_CAST((obj), GTK_TYPE_BLOCK_VIEW, GtkBlockView))
#define GTK_BLOCK_VIEW_CLASS(klass)          (G_TYPE_CHECK_CLASS_CAST((klass), GTK_TYPE_BLOCK_VIEW, GtkBlockViewClass))
#define GTK_IS_BLOCK_VIEW(obj)               (G_TYPE_CHECK_INSTANCE_TYPE((obj), GTK_TYPE_BLOCK_VIEW))
#define GTK_IS_BLOCK_VIEW_CLASS(klass)       (G_TYPE_CHECK_CLASS_TYPE((klass), GTK_TYPE_BLOCK_VIEW))
#define GTK_BLOCK_VIEW_GET_CLASS(obj)        (G_TYPE_INSTANCE_GET_CLASS((obj), GTK_TYPE_BLOCK_VIEW, GtkBlockViewClass))


/* Composant d'affichage de code d'assembleur (instance) */
typedef struct _GtkBlockView GtkBlockView;

/* Composant d'affichage de code d'assembleur (classe) */
typedef struct _GtkBlockViewClass GtkBlockViewClass;


/* Détermine le type du composant d'affichage de bloc en langage d'assemblage. */
GType gtk_block_view_get_type(void);

/* Crée un nouveau composant pour l'affichage de bloc en ASM. */
GtkWidget *gtk_block_view_new(void);



#endif  /* _GTKEXT_GTKBLOCKVIEW_H */
